package edu.gmu.cs475;

import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import java.util.ArrayList;

/**
 * Implement Part 4 here
 */
public class Part4TestingTheTestTests {
	@Rule
	public Timeout globalTimeout = new Timeout(6000);


	/**
	 * This test should fail if and only if the KeyValueStore being tested does not allow
	 * for two concurrent calls to addToList or deleteFromList to occur simultaneously under
	 * different keys.
	 * <p>
	 * As a hint, we suggest that you consider modifying the behavior of list.add and list.remove
	 * for the two keys that you will be storing and testing. We include the snippet in the test to
	 * demonstrate how to do this.
	 * <p>
	 * Your test should fail by calling Assert.assert* or Assert.fail.
	 */
	@Test
	public void testAddOrDeleteFromDifferentListsShouldBeConcurrent() throws InterruptedException {
		KeyValueStore kvStore = new KeyValueStore();
		String lk1 = "listKey1";
		String lk2 = "listKey2";
		kvStore.set(lk1, new ArrayList<String>() {
			@Override
			public boolean add(String s) {
				System.out.println("Add was called on key 1, to add " + s);
				return super.add(s);
			}

			@Override
			public boolean remove(Object o) {
				return super.remove(o);
			}
		});
		kvStore.set(lk2, new ArrayList<String>() {
			@Override
			public boolean add(String s) {
				return super.add(s);
			}

			@Override
			public boolean remove(Object o) {
				return super.remove(o);
			}
		});

		kvStore.addToList(lk1, "abcd");
		kvStore.addToList(lk2, "abcd");
		Assert.fail("This test has not been implemented yet");
	}
}
